property debug_me : false

property first_run : true
property sort_results_by_user : false
property show_failures : true
property show_successes : true
property show_ssh : true

property MacOS_version : ""
property uid_path : ""

property section_divider : return & 
	"___________________________________________________________________________" & return & 
	"___________________________________________________________________________" & return & return
property macintouch_url : "http://www.macintouch.com/security-mon.html"

on will finish launching the_object
	try
		set MacOS_version to (my gestalt_version_info("sysv", 4))
	on error
		set MacOS_version to ""
	end try
	if MacOS_version  "10.4" and MacOS_version < "10.4.2" then
		set uid_path to ((quoted form of ((main bundle's resource path) & "/uid")) & " ")
	else
		set uid_path to ""
	end if
	
	my register_settings()
	my read_settings()
end will finish launching

on awake from nib the_object
	set object_name to the_object's name as Unicode text
	if object_name = "main" then
		my load_help_rtf()
		tell the_object
			if first_run then center
		end tell
		
	else if object_name = "prefs" then
		tell the_object
			set current row of matrix "sort_results_by_user" to ((sort_results_by_user as integer) + 1)
			set state of button "show_failures" to (show_failures as integer)
			set state of button "show_successes" to (show_successes as integer)
			set state of button "show_ssh" to (show_ssh as integer)
		end tell
	end if
end awake from nib

on launched the_object
	if first_run then set first_run to false
	my write_settings()
	show window "main"
end launched

on choose menu item the_object
	set object_name to the_object's name as Unicode text
	
	if object_name = "help" then
		my load_help_rtf()
		
	else if object_name = "prefs" then
		display panel window "prefs" attached to window "main"
		
	end if
end choose menu item

on load_help_rtf()
	set the_tv to text view 1 of scroll view 1 of window "main"
	call method "readRTFDFromFile:" of the_tv with parameter (call method "getRTFPath:" of class "methods" with parameter "readme")
end load_help_rtf

on clicked the_object
	set object_name to the_object's name as Unicode text
	
	if object_name = "quit" then
		quit
		
	else if object_name = "save" then
		set the_file to (choose file name with prompt (my uis("s001")) default name (my uis("s002"))) as Unicode text
		set the_string to contents of text view 1 of scroll view 1 of window "main"
		my write_to_file(the_file, the_string, false, "R*ch", "TEXT")
		
	else if object_name = "run" then
		tell window "progress"
			set indeterminate of progress indicator 1 to true
			set uses threaded animation of progress indicator 1 to true
			tell progress indicator 1 to start
		end tell
		display panel window "progress" attached to window "main"
		set {got_result, the_result} to my check_fpa()
		if not got_result then
			my close_progress()
			activate
			if the_result contains "incorrect password" then set the_result to my uis("s003")
			display alert my uis("s004") as critical message the_result default button my uis("s005") attached to window "main"
		else
			my close_progress()
			tell window "main"
				set contents of text view 1 of scroll view 1 to the_result
				set enabled of button "save" to true
			end tell
		end if
		
	else if object_name = "prefs" then
		display panel window "prefs" attached to window "main"
		
	else if object_name = "prefs_ok" then
		close panel window "prefs"
		
	else if object_name = "sort_results_by_user" then
		set sort_results_by_user to ((the_object's current row) - 1) as boolean
		my write_settings()
		
	else if object_name = "show_failures" then
		set show_failures to (the_object's state) as boolean
		my write_settings()
		
	else if object_name = "show_successes" then
		set show_successes to (the_object's state) as boolean
		my write_settings()
		
	else if object_name = "show_ssh" then
		set show_ssh to (the_object's state) as boolean
		my write_settings()
		
	else if object_name = "visit_macintouch" then
		open location macintouch_url
		
	end if
	
end clicked

on should quit after last window closed the_object
	return true
end should quit after last window closed

on check_fpa()
	try
		set return_string to {}
		set secure_log to "/var/log/secure.log"
		set system_log to "/var/log/system.log"
		if sort_results_by_user then
			set sort_results to ""
		else
			set sort_results to " | sort -nr"
		end if
		if MacOS_version  "10.4" then
			set sed_grep to "sed 's/^.*user \\(.*\\)$/\\1/'"
		else
			set sed_grep to "sed 's/^.*user \\(.*\\) for.*$/\\1/'"
		end if
		try
			get (secure_log as POSIX file) as alias
			set secure_log_found to true
			if (info for ((secure_log as POSIX file) as alias))'s size = 0 then
				set secure_log_found to false
				set end of return_string to my uis("s007")
			end if
		on error
			set secure_log_found to false
			set end of return_string to my uis("s006")
		end try
		
		if secure_log_found then
			set shell_script to (uid_path & "sudo awk 'NR == 1 { print $1, $2, $3 }' " & secure_log)
			set secure_log_start_date to do shell script shell_script with administrator privileges
			set failure_summary_header to my uis_r("s008", {secure_log_start_date})
			
			--All failures: 
			set shell_script to (uid_path & "sudo grep 'failed to auth' " & secure_log & " | " & sed_grep & " | sort | uniq -c" & sort_results)
			set failure_summary to (do shell script shell_script with administrator privileges)'s paragraphs
			if failure_summary = {""} then set failure_summary to my uis("s033") & return
			
			--Failures on login:
			set shell_script to (uid_path & "sudo grep 'failed to auth' " & secure_log & " | grep 'system.login.tty' | " & sed_grep & " | sort | uniq -c" & sort_results)
			set login_failure_summary to (do shell script shell_script with administrator privileges)'s paragraphs
			
			if class of failure_summary = list then
				repeat with i from 1 to (count failure_summary)
					try
						set this_para to failure_summary's item i
						try
							set login_failure to (login_failure_summary's item i)'s word 1 as integer
							if login_failure = 1 then
								set login_failure to my uis("s019")
							else
								set login_failure to my uis_r("s020", {login_failure})
							end if
						on error
							set login_failure to ""
						end try
						set the_plural to my uis("s010")
						if (this_para's word 1 as integer) = 1 then set the_plural to ""
						tell (a reference to my text item delimiters)
							set {o, contents} to {contents, space}
							set {user_account, contents} to {"" & this_para's words 2 thru -1, o}
						end tell
						set user_account to user_account & "."
						set failure_summary's item i to (tab & this_para's word 1 & tab & my uis_r("s011", {the_plural, user_account, login_failure}))
					on error
						try
							tell (a reference to my text item delimiters) to set contents to o
						end try
						set failure_summary's item i to ""
					end try
				end repeat
			end if
			set end of return_string to failure_summary_header
			set end of return_string to failure_summary
			
			set success_summary_header to my uis_r("s016", {secure_log_start_date})
			
			--All successes:
			set shell_script to (uid_path & "sudo grep 'authenticated' " & secure_log & " | " & sed_grep & " | sort | uniq -c" & sort_results)
			set succes_summary to (do shell script shell_script with administrator privileges)'s paragraphs
			
			repeat with i from 1 to (count succes_summary)
				try
					set this_para to succes_summary's item i
					set the_plural to my uis("s021")
					if (this_para's word 1 as integer) = 1 then set the_plural to ""
					tell (a reference to my text item delimiters)
						set {o, contents} to {contents, space}
						set {user_account, contents} to {"" & this_para's words 2 thru -1, o}
					end tell
					try
						if user_account's word 2 = "uid" then set user_account to user_account's word 1 & my uis_r("s023", {user_account's word -1})
					end try
					try
						if user_account = "authenticated" then set user_account to my uis("s024")
					end try
					set user_account to user_account & "."
					set succes_summary's item i to (tab & this_para's word 1 & tab & my uis_r("s022", {the_plural, user_account}))
				on error
					try
						tell (a reference to my text item delimiters) to set contents to o
					end try
					set succes_summary's item i to ""
				end try
			end repeat
			set end of return_string to section_divider
			set end of return_string to success_summary_header
			set end of return_string to succes_summary
			
			if show_failures then
				set all_failures_header to my uis_r("s009", {secure_log_start_date})
				set shell_script to (uid_path & "sudo grep 'failed to auth' " & secure_log)
				try
					set all_failures to (do shell script shell_script with administrator privileges)
				on error
					set all_failures to my uis("s033")
				end try
				set end of return_string to section_divider
				set end of return_string to all_failures_header
				set end of return_string to all_failures & return
			end if
			
			if show_successes then
				set all_successes_header to my uis_r("s017", {secure_log_start_date})
				set shell_script to (uid_path & "sudo grep 'authenticated' " & secure_log)
				try
					set all_successes to (do shell script shell_script with administrator privileges)
				on error
					set all_successes to my uis("s034")
				end try
				set end of return_string to section_divider
				set end of return_string to all_successes_header
				set end of return_string to all_successes & return
			end if
		end if
		
		if show_ssh then
			try
				get (system_log as POSIX file) as alias
				set system_log_found to true
				if (info for ((system_log as POSIX file) as alias))'s size = 0 then
					set system_log_found to false
					set end of return_string to my uis("s032")
				end if
			on error
				set system_log_found to false
				set end of return_string to my uis("s031")
			end try
			
			if system_log_found then
				try
					set ssh_attempts to (do shell script "grep sshd " & system_log)
					set ssh_attempts to my uis_r("s025", {ssh_attempts})
				on error
					set ssh_attempts to my uis("s026")
				end try
				set end of return_string to section_divider
				set end of return_string to ssh_attempts
				
				try
					set illegal_ssh_attempts to (do shell script "(cat " & system_log & "; zcat " & system_log & "*.gz) | grep -i ssh | grep -i illegal")
					set illegal_ssh_attempts to my uis_r("s027", {ssh_attempts})
				on error
					set illegal_ssh_attempts to my uis("s028")
				end try
				set end of return_string to section_divider
				set end of return_string to illegal_ssh_attempts
				
				try
					set accepted_ssh_attempts to (do shell script "(cat " & system_log & "; zcat " & system_log & "*.gz) | grep -i ssh | grep -i  accepted")
					set accepted_ssh_attempts to my uis_r("s029", {ssh_attempts})
				on error
					set accepted_ssh_attempts to my uis("s030")
				end try
				set end of return_string to section_divider
				set end of return_string to accepted_ssh_attempts
			end if
		end if
		
		try
			set shell_script to (uid_path & "sudo -k") --clear the authentication
			do shell script shell_script
		end try
		
		return {true, "" & return_string}
	on error e
		try
			set shell_script to (uid_path & "sudo -k") --clear the authentication
			do shell script shell_script
		end try
		if e = my uis("s014") then return {true, my uis("s015")}
		return {false, e}
	end try
end check_fpa

on register_settings()
	set {the_settings, the_settings_names} to my get_settings()
	tell user defaults
		repeat with i from 1 to (count the_settings_names)
			try
				make new default entry at end of default entries with properties {name:(item i of the_settings_names), contents:(item i of the_settings)}
			end try
		end repeat
		register
	end tell
end register_settings

on read_settings()
	set {the_settings, the_settings_names} to my get_settings()
	tell user defaults
		repeat with i from 1 to (count the_settings_names)
			try
				set item i of the_settings to contents of default entry (item i of the_settings_names)
			end try
		end repeat
	end tell
	my assign_settings(the_settings)
end read_settings

on write_settings()
	set {the_settings, the_settings_names} to my get_settings()
	tell user defaults
		repeat with i from 1 to (count the_settings_names)
			try
				set contents of default entry (item i of the_settings_names) to (item i of the_settings)
			end try
		end repeat
	end tell
end write_settings

on assign_settings(the_settings)
	set {first_run, sort_results_by_user, show_failures, show_successes, show_ssh} to the_settings
end assign_settings

on get_settings()
	set the_settings to {first_run, sort_results_by_user, show_failures, show_successes, show_ssh}
	set the_settings_names to {"first_run", "sort_results_by_user", "show_failures", "show_successes", "show_ssh"}
	return {the_settings, the_settings_names}
end get_settings

on write_to_file(the_file, the_string, with_appending, creator_code, file_type)
	try
		set the_file to the_file as file specification
		open for access the_file with write permission
		if with_appending = false then set eof of the_file to 0
		write the_string to the_file starting at eof as (class of the_string)
		close access the_file
		try
			tell application "System Events"
				if creator_code  "" then set creator type of file (the_file as string) to creator_code
				if file_type  "" then set file type of file (the_file as string) to file_type
			end tell
		end try
	on error the_error
		try
			close access the_file
		end try
	end try
end write_to_file

on close_progress()
	close panel window "progress"
	tell window "progress"'s progress indicator 1 to stop
end close_progress

on uis(i)
	return (localized string i from table "ui")
end uis

on uis_r(i, r)
	set s to (localized string i from table "ui")
	repeat with j from 1 to (count r)
		set s to my snr(s, ("%" & j), r's item j)
	end repeat
	return s
end uis_r

on snr(the_string, search_string, replace_string)
	tell (a reference to my text item delimiters)
		set {old_atid, contents} to {contents, search_string}
		set {the_string, contents} to {the_string's text items, replace_string}
		set {the_string, contents} to {"" & the_string, old_atid}
	end tell
	return the_string
end snr

on update_status(s)
	if debug_me then log s
end update_status

on gestalt_version_info(gestalt_code, string_length)
	try
		set {a, b, c, d} to (my num_to_hex((system attribute gestalt_code), string_length))
		if a = "0" then set a to ""
		return ("" & {a, b, ".", c, ".", d})
	on error
		return "unknown"
	end try
end gestalt_version_info

on num_to_hex(hex_data, string_length)
	set hex_string to {}
	repeat with i from string_length to 1 by -1
		set hex_string to ((hex_data mod 16) as string) & hex_string
		set hex_data to hex_data div 16
	end repeat
	return ("" & hex_string)
end num_to_hex
